package com.kiz10;
import flash.display.Loader;
import flash.events.IOErrorEvent;
import flash.errors.IOError;
import flash.events.Event;
import flash.net.URLRequest;
import flash.system.Security;

/**
 * ...
 * @author Junjo
 */

 typedef Kiz10Response = {
	var success:Bool;
	var responseCode:String;
	var data:Dynamic;
}

class Kiz10API
{
	public static var api:Dynamic;
	public static var apiLoaded:Bool = false;
	
	private static inline var API_URL:String = "http://kiz10.com/applications/controllers/Kiz10API.swf";
	private static var init_callback:Kiz10Response-> Void;
	private static var apiLoader:Loader;
	
	private static var id_game:Int;
	private static var api_key:String;
	
	public static function init(idGame:Int, apiKey:String, ?callback:Kiz10Response-> Void = null):Void {
		id_game = idGame;
		api_key = apiKey;
		init_callback = callback;
		
		Security.allowDomain(API_URL);
		apiLoader = new Loader();
        apiLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, onInitLoadComplete, false, 0, true);
        apiLoader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, onInitError, false, 0, true);
        apiLoader.load(new URLRequest(API_URL));
	}
	
	private static function onInitError(e:IOError):Void {
        apiLoader.contentLoaderInfo.removeEventListener(Event.COMPLETE, onInitLoadComplete);
        apiLoader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, onInitError);
		if (init_callback != null) {
			init_callback( { success:false, responseCode:"IO_ERROR", data:null } );
		}
	}
	
	private static function onInitLoadComplete(e:Event):Void {
        apiLoader.contentLoaderInfo.removeEventListener(Event.COMPLETE, onInitLoadComplete);
        apiLoader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, onInitError);
		api = e.target.content;
		api.init(id_game, api_key);
		apiLoaded = true;
		if (init_callback != null) {
			init_callback({ success:true, responseCode:"OK", data:null });
		}
	}
	
	public static function submitStat(stat:String, value:Int):Void {
		if (apiLoaded) {
			api.submitStat(stat, value);
		}
	}
	
	public static function submitAchievProgress(achievement:String, progress:Int):Void {
		if (apiLoaded) {
			api.submitAchievProgress(achievement, progress);
		}
	}
	
}